#include "eudoraHandler.h"

#include <stdio.h>
#include <string.h>

void getTOCHeaderBlock (FILE *tocFile, struct TOCHeaderBlock &header)
{	//Read eudora version:
	fseek (tocFile, 0, SEEK_SET);
	fread (header.eudoraVersion, 1, 6, tocFile);
	header.eudoraVersion[6] = '\0';
	//printf ("version: %s\n", header.eudoraVersion);

	//Read mail box name:
	fseek (tocFile, 8, SEEK_SET);
	fread (header.mailBoxName, 1, 28, tocFile);
	//printf ("mail box name: %s\n", header.mailBoxName);
	
	//Read mailBoxType:
	fseek (tocFile, 40, SEEK_SET);
	fread (&header.mailBoxType, 1, 2, tocFile);
	//printf ("mail box type: %d\n", header.mailBoxType);
	
	//Read Number of messages:
	fseek (tocFile, 102, SEEK_SET);
	fread (&header.numMessages, 1, 2, tocFile);
	printf ("# messages in box: %d\n", header.numMessages);
}
//------------------------------------------------------------------//
void getTOCMessageBlock (FILE *tocFile, unsigned int msgNum, struct TOCMessageBlock &msgBlock)
{	//Find the msg byte offset for msgNum message:
	unsigned long int msgBlockOffset = TOCGetOffset (msgNum);
	char	tempChr;

	//Seek to msgBlockHeader:
	fseek (tocFile, msgBlockOffset, SEEK_SET);

	//Read offset of msg in mbx:
	fread (&msgBlock.mbxOffset, 1, 4, tocFile);
	//printf ("mbx offset %d\n", msgBlock.mbxOffset);
	fread (&msgBlock.mbxMsgLength, 1, 4, tocFile);
	//printf ("mbx length %d\n", msgBlock.mbxMsgLength);
	fread (&msgBlock.msgDate, 1, 4, tocFile);
	//printf ("mbx date %d\n", msgBlock.msgDate);
	fread (&msgBlock.msgStatus, 1, 2, tocFile);
	//printf ("mbx status %d\n", msgBlock.msgStatus);

	//Seek to the Sender:
	fseek (tocFile, msgBlockOffset + 50, SEEK_SET);
	//Read the sender:
	fread (&msgBlock.sender, 1, 64, tocFile);
	//printf ("mbx sender %s\n", msgBlock.sender);
	fread (&msgBlock.subject, 1, 64, tocFile);
	//printf ("mbx subject %s\n", msgBlock.subject);
}
//------------------------------------------------------------------//
unsigned long int TOCGetOffset (unsigned int msgNum)
{
	return (msgNum - 1) * 218 + 104;
}
//------------------------------------------------------------------//