#ifndef EUDORAHANDLER_H
#define EUDORAHANDLER_H

#include <stdio.h>

//**---------------TOC FILE HANDLING--------------------**//

//TOC Files start with a "Header Block"
//--This block is the first 104 bytes of the TOC file.
struct	TOCHeaderBlock
{	//File position 0-5
	char eudoraVersion[6+1];
	//File position 8-36
	char mailBoxName[28];
	//File position 40-41
	unsigned short int mailBoxType;
	//File position 102-103
	unsigned short int numMessages;
};
//Function which extracts the Header Block from the *.toc file:
void getTOCHeaderBlock (FILE *tocFile, struct TOCHeaderBlock &header);

//MESSAGE BLOCK
//--Each Message Entry Block is 218 bytes in size.
struct	TOCMessageBlock
{
	//Where the corresponding message begins in the MBX file:
	//Bytes 0-3:
	unsigned long int	mbxOffset;
	//How long the message is in the mbx file:
	//Bytes 4-7:
	unsigned long int	mbxMsgLength;
	//Some type of Date format:
	//Bytes 8-11
	unsigned long int	msgDate;
	//Message status:
	//Bytes 12-13
	unsigned short int	msgStatus;
	//From, sender
	//Bytes 50-113
	char	sender[64];
	//Subject
	//Bytes 114-177
	char	subject[64];
};

//Extracts Message Block for msgNum message.
void getTOCMessageBlock (FILE *tocFile, unsigned int msgNum, struct TOCMessageBlock &msgBlock);

//Function to find offset for a Specific message in the TOC:
unsigned long int TOCGetOffset (unsigned int msgNum);

//**---------------MBX FILE HANDLING--------------------**//
#endif
