//BeOS includes:
#include <StorageKit.h>

//ANSI C includes:
#include <stdio.h>
#include <string.h>

//Custom includes:
#include "eudoraToBeMail.h"

int main ()
{
 
	BDirectory	currentDirectory;

	BEntry		currentDirEntry;
	BEntry		tempBEntry;
	char		tempFileName[B_FILE_NAME_LENGTH];
	char		entryFileName[B_FILE_NAME_LENGTH];
	char		dotToc[] = {'.','t','o','c'};

	//Set the current directory for traversing:
	if (currentDirectory.SetTo (".") != B_OK)
		printf ("BDirectory SetTo (...) returned an error for currentDirectory...\n");

	//Obtain the list of Eudora Mailboxes in this directory:
	while (currentDirectory.GetNextEntry (&currentDirEntry, false) == B_OK)
	{	//Get the next entry's name:
		if (currentDirEntry.GetName (entryFileName) != B_OK)
			printf ("BEntry GetName (...) for currentDirEntry...\n");

		//Decide if this entry is a Eudora File:
		if (memcmp ((entryFileName + strlen (entryFileName) - 4), dotToc, 4) == 0)
		{	//Confirm existence of correpsonding mbx file:
			strcpy (tempFileName, entryFileName);
			strcpy ((tempFileName + strlen (entryFileName) - 4), ".mbx");
			tempBEntry.SetTo (tempFileName, false);

			if (!tempBEntry.Exists ())
				printf ("NOTE: %s found, but corresponding %s not found...this mailbox will not be converted.\n", entryFileName, tempFileName);
					
			else	//If the corresponding mbx file exists:
			{
				printf ("%s found and corresponding %s found:\n", entryFileName, tempFileName);	
				//Remove file extension from tempFileName string:
				tempFileName[strlen (tempFileName) - 4] = '\0';

				eudoraBoxToBeMail (tempFileName);
			}
		}//End if toc file found.

	}//End While directory entries.
	
	printf ("EudoraToBeMail finished executing...\n");

	return 0;
}
